Index: src/molecule_fragmentation.cpp
===================================================================
--- src/molecule_fragmentation.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/molecule_fragmentation.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -8,4 +8,5 @@
 #include <cstring>
 
+#include "World.hpp"
 #include "atom.hpp"
 #include "bond.hpp"
@@ -18,4 +19,5 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
+#include "World.hpp"
 
 /************************************* Functions for class molecule *********************************/
@@ -43,5 +45,5 @@
   }
   FragmentCount = NoNonHydrogen*(1 << (c*order));
-  Log() << Verbose(1) << "Upper limit for this subgraph is " << FragmentCount << " for " << NoNonHydrogen << " non-H atoms with maximum bond degree of " << c << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Upper limit for this subgraph is " << FragmentCount << " for " << NoNonHydrogen << " non-H atoms with maximum bond degree of " << c << "." << endl);
   return FragmentCount;
 };
@@ -67,9 +69,9 @@
     } // else it's "-1" or else and thus must not be added
   }
-  Log() << Verbose(1) << "The scanned KeySet is ";
+  DoLog(1) && (Log() << Verbose(1) << "The scanned KeySet is ");
   for(KeySet::iterator runner = CurrentSet.begin(); runner != CurrentSet.end(); runner++) {
-    Log() << Verbose(0) << (*runner) << "\t";
-  }
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << (*runner) << "\t");
+  }
+  DoLog(0) && (Log() << Verbose(0) << endl);
   return (status != 0);
 };
@@ -99,5 +101,5 @@
 
   // 1st pass: open file and read
-  Log() << Verbose(1) << "Parsing the KeySet file ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Parsing the KeySet file ... " << endl);
   sprintf(filename, "%s/%s%s", path, FRAGMENTPREFIX, KEYSETFILE);
   InputFile.open(filename);
@@ -112,5 +114,5 @@
         testGraphInsert = FragmentList->insert(GraphPair (CurrentSet,pair<int,double>(NumberOfFragments++,1)));  // store fragment number and current factor
         if (!testGraphInsert.second) {
-          eLog() << Verbose(0) << "KeySet file must be corrupt as there are two equal key sets therein!" << endl;
+          DoeLog(0) && (eLog()<< Verbose(0) << "KeySet file must be corrupt as there are two equal key sets therein!" << endl);
           performCriticalExit();
         }
@@ -121,7 +123,7 @@
     InputFile.clear();
     Free(&buffer);
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
-    Log() << Verbose(1) << "File " << filename << " not found." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "File " << filename << " not found." << endl);
     status = false;
   }
@@ -153,5 +155,5 @@
 
   // 2nd pass: open TEFactors file and read
-  Log() << Verbose(1) << "Parsing the TEFactors file ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Parsing the TEFactors file ... " << endl);
   sprintf(filename, "%s/%s%s", path, FRAGMENTPREFIX, TEFACTORSFILE);
   InputFile.open(filename);
@@ -163,5 +165,5 @@
         InputFile >> TEFactor;
         (*runner).second.second = TEFactor;
-        Log() << Verbose(2) << "Setting " << ++NumberOfFragments << " fragment's TEFactor to " << (*runner).second.second << "." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Setting " << ++NumberOfFragments << " fragment's TEFactor to " << (*runner).second.second << "." << endl);
       } else {
         status = false;
@@ -171,7 +173,7 @@
     // 4. Free and done
     InputFile.close();
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
-    Log() << Verbose(1) << "File " << filename << " not found." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "File " << filename << " not found." << endl);
     status = false;
   }
@@ -201,5 +203,5 @@
   line += KEYSETFILE;
   output.open(line.c_str(), ios::out);
-  Log() << Verbose(1) << "Saving key sets of the total graph ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving key sets of the total graph ... ");
   if(output != NULL) {
     for(Graph::iterator runner = KeySetList.begin(); runner != KeySetList.end(); runner++) {
@@ -211,7 +213,7 @@
       output << endl;
     }
-    Log() << Verbose(0) << "done." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "done." << endl);
   } else {
-    eLog() << Verbose(0) << "Unable to open " << line << " for writing keysets!" << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "Unable to open " << line << " for writing keysets!" << endl);
     performCriticalExit();
     status = false;
@@ -242,11 +244,11 @@
   line += TEFACTORSFILE;
   output.open(line.c_str(), ios::out);
-  Log() << Verbose(1) << "Saving TEFactors of the total graph ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving TEFactors of the total graph ... ");
   if(output != NULL) {
     for(Graph::iterator runner = KeySetList.begin(); runner != KeySetList.end(); runner++)
       output << (*runner).second.second << endl;
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
-    Log() << Verbose(1) << "failed to open " << line << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open " << line << "." << endl);
     status = false;
   }
@@ -292,13 +294,13 @@
         (*PresentItem).second.first = fabs(Value);
         (*PresentItem).second.second = FragOrder;
-        Log() << Verbose(2) << "Updated element (" <<  (*PresentItem).first << ",[" << (*PresentItem).second.first << "," << (*PresentItem).second.second << "])." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Updated element (" <<  (*PresentItem).first << ",[" << (*PresentItem).second.first << "," << (*PresentItem).second.second << "])." << endl);
       } else {
-        Log() << Verbose(2) << "Did not update element " <<  (*PresentItem).first << " as " << FragOrder << " is less than or equal to " << (*PresentItem).second.second << "." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Did not update element " <<  (*PresentItem).first << " as " << FragOrder << " is less than or equal to " << (*PresentItem).second.second << "." << endl);
       }
     } else {
-      Log() << Verbose(2) << "Inserted element (" <<  (*PresentItem).first << ",[" << (*PresentItem).second.first << "," << (*PresentItem).second.second << "])." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "Inserted element (" <<  (*PresentItem).first << ",[" << (*PresentItem).second.first << "," << (*PresentItem).second.second << "])." << endl);
     }
   } else {
-    Log() << Verbose(1) << "No Fragment under No. " << No << "found." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "No Fragment under No. " << No << "found." << endl);
   }
 };
@@ -359,5 +361,5 @@
   atom *Walker = mol->start;
   map<double, pair<int,int> > *FinalRootCandidates = new map<double, pair<int,int> > ;
-  Log() << Verbose(1) << "Root candidate list is: " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Root candidate list is: " << endl);
   for(map<int, pair<double,int> >::iterator runner = AdaptiveCriteriaList->begin(); runner != AdaptiveCriteriaList->end(); runner++) {
     Walker = mol->FindAtom((*runner).first);
@@ -365,11 +367,11 @@
       //if ((*runner).second.second >= Walker->AdaptiveOrder) { // only insert if this is an "active" root site for the current order
       if (!Walker->MaxOrder) {
-        Log() << Verbose(2) << "(" << (*runner).first << ",[" << (*runner).second.first << "," << (*runner).second.second << "])" << endl;
+        DoLog(2) && (Log() << Verbose(2) << "(" << (*runner).first << ",[" << (*runner).second.first << "," << (*runner).second.second << "])" << endl);
         FinalRootCandidates->insert( make_pair( (*runner).second.first, pair<int,int>((*runner).first, (*runner).second.second) ) );
       } else {
-        Log() << Verbose(2) << "Excluding (" << *Walker << ", " << (*runner).first << ",[" << (*runner).second.first << "," << (*runner).second.second << "]), as it has reached its maximum order." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Excluding (" << *Walker << ", " << (*runner).first << ",[" << (*runner).second.first << "," << (*runner).second.second << "]), as it has reached its maximum order." << endl);
       }
     } else {
-      eLog() << Verbose(0) << "Atom No. " << (*runner).second.first << " was not found in this molecule." << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Atom No. " << (*runner).second.first << " was not found in this molecule." << endl);
       performCriticalExit();
     }
@@ -396,5 +398,5 @@
     Walker = mol->FindAtom(No);
     //if (Walker->AdaptiveOrder < MinimumRingSize[Walker->nr]) {
-      Log() << Verbose(2) << "Root " << No << " is still above threshold (10^{" << Order <<"}: " << runner->first << ", setting entry " << No << " of Atom mask to true." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "Root " << No << " is still above threshold (10^{" << Order <<"}: " << runner->first << ", setting entry " << No << " of Atom mask to true." << endl);
       AtomMask[No] = true;
       status = true;
@@ -412,12 +414,12 @@
 void PrintAtomMask(bool *AtomMask, int AtomCount)
 {
-  Log() << Verbose(2) << "              ";
+  DoLog(2) && (Log() << Verbose(2) << "              ");
   for(int i=0;i<AtomCount;i++)
-    Log() << Verbose(0) << (i % 10);
-  Log() << Verbose(0) << endl;
-  Log() << Verbose(2) << "Atom mask is: ";
+    DoLog(0) && (Log() << Verbose(0) << (i % 10));
+  DoLog(0) && (Log() << Verbose(0) << endl);
+  DoLog(2) && (Log() << Verbose(2) << "Atom mask is: ");
   for(int i=0;i<AtomCount;i++)
-    Log() << Verbose(0) << (AtomMask[i] ? "t" : "f");
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << (AtomMask[i] ? "t" : "f"));
+  DoLog(0) && (Log() << Verbose(0) << endl);
 };
 
@@ -446,5 +448,5 @@
     // transmorph graph keyset list into indexed KeySetList
     if (GlobalKeySetList == NULL) {
-      eLog() << Verbose(1) << "Given global key set list (graph) is NULL!" << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "Given global key set list (graph) is NULL!" << endl);
       return false;
     }
@@ -454,5 +456,5 @@
     map<int, pair<double,int> > *AdaptiveCriteriaList = ScanAdaptiveFileIntoMap(path, *IndexKeySetList); // (Root No., (Value, Order)) !
     if (AdaptiveCriteriaList->empty()) {
-      eLog() << Verbose(2) << "Unable to parse file, incrementing all." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Unable to parse file, incrementing all." << endl);
       while (Walker->next != end) {
         Walker = Walker->next;
@@ -492,7 +494,7 @@
     if (!status) {
       if (Order == 0)
-        Log() << Verbose(1) << "Single stepping done." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Single stepping done." << endl);
       else
-        Log() << Verbose(1) << "Order at every site is already equal or above desired order " << Order << "." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Order at every site is already equal or above desired order " << Order << "." << endl);
     }
   }
@@ -511,5 +513,5 @@
 {
   if (SortIndex != NULL) {
-    Log() << Verbose(1) << "SortIndex is " << SortIndex << " and not NULL as expected." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "SortIndex is " << SortIndex << " and not NULL as expected." << endl);
     return false;
   }
@@ -562,9 +564,9 @@
   bool *AtomMask = NULL;
 
-  Log() << Verbose(0) << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
 #ifdef ADDHYDROGEN
-  Log() << Verbose(0) << "I will treat hydrogen special and saturate dangling bonds with it." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "I will treat hydrogen special and saturate dangling bonds with it." << endl);
 #else
-  Log() << Verbose(0) << "Hydrogen is treated just like the rest of the lot." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Hydrogen is treated just like the rest of the lot." << endl);
 #endif
 
@@ -592,5 +594,5 @@
     // fill the bond structure of the individually stored subgraphs
   MolecularWalker->FillBondStructureFromReference(this, FragmentCounter, ListOfLocalAtoms, false);  // we want to keep the created ListOfLocalAtoms
-    Log() << Verbose(0) << "Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl);
     LocalBackEdgeStack = new StackClass<bond *> (MolecularWalker->Leaf->BondCount);
 //    // check the list of local atoms for debugging
@@ -601,9 +603,9 @@
 //      else
 //        Log() << Verbose(0) << "\t" << ListOfLocalAtoms[FragmentCounter][i]->Name;
-    Log() << Verbose(0) << "Gathering local back edges for subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Gathering local back edges for subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl);
     MolecularWalker->Leaf->PickLocalBackEdges(ListOfLocalAtoms[FragmentCounter++], BackEdgeStack, LocalBackEdgeStack);
-    Log() << Verbose(0) << "Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl);
     MolecularWalker->Leaf->CyclicStructureAnalysis(LocalBackEdgeStack, MinimumRingSize);
-    Log() << Verbose(0) << "Done with Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Done with Analysing the cycles of subgraph " << MolecularWalker->Leaf << " with nr. " << FragmentCounter << "." << endl);
     delete(LocalBackEdgeStack);
   }
@@ -636,17 +638,17 @@
     while (MolecularWalker->next != NULL) {
       MolecularWalker = MolecularWalker->next;
-      Log() << Verbose(1) << "Fragmenting subgraph " << MolecularWalker << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Fragmenting subgraph " << MolecularWalker << "." << endl);
       //MolecularWalker->Leaf->OutputListOfBonds(out);  // output atom::ListOfBonds for debugging
       if (MolecularWalker->Leaf->first->next != MolecularWalker->Leaf->last) {
         // call BOSSANOVA method
-        Log() << Verbose(0) << endl << " ========== BOND ENERGY of subgraph " << FragmentCounter << " ========================= " << endl;
+        DoLog(0) && (Log() << Verbose(0) << endl << " ========== BOND ENERGY of subgraph " << FragmentCounter << " ========================= " << endl);
         MolecularWalker->Leaf->FragmentBOSSANOVA(FragmentList[FragmentCounter], RootStack[FragmentCounter], MinimumRingSize);
       } else {
-        eLog() << Verbose(1) << "Subgraph " << MolecularWalker << " has no atoms!" << endl;
+        DoeLog(1) && (eLog()<< Verbose(1) << "Subgraph " << MolecularWalker << " has no atoms!" << endl);
       }
       FragmentCounter++;  // next fragment list
     }
   }
-  Log() << Verbose(2) << "CheckOrder is " << CheckOrder << "." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "CheckOrder is " << CheckOrder << "." << endl);
   delete[](RootStack);
   delete[](AtomMask);
@@ -675,13 +677,13 @@
   //if (FragmentationToDo) {    // we should always store the fragments again as coordination might have changed slightly without changing bond structure
   // allocate memory for the pointer array and transmorph graphs into full molecular fragments
-  BondFragments = new MoleculeListClass();
+  BondFragments = new MoleculeListClass(World::getPointer());
   int k=0;
   for(Graph::iterator runner = TotalGraph.begin(); runner != TotalGraph.end(); runner++) {
     KeySet test = (*runner).first;
-    Log() << Verbose(0) << "Fragment No." << (*runner).second.first << " with TEFactor " << (*runner).second.second << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Fragment No." << (*runner).second.first << " with TEFactor " << (*runner).second.second << "." << endl);
     BondFragments->insert(StoreFragmentFromKeySet(test, configuration));
     k++;
   }
-  Log() << Verbose(0) << k << "/" << BondFragments->ListOfMolecules.size() << " fragments generated from the keysets." << endl;
+  DoLog(0) && (Log() << Verbose(0) << k << "/" << BondFragments->ListOfMolecules.size() << " fragments generated from the keysets." << endl);
 
   // ===== 9. Save fragments' configuration and keyset files et al to disk ===
@@ -690,9 +692,9 @@
     CreateMappingLabelsToConfigSequence(SortIndex);
 
-    Log() << Verbose(1) << "Writing " << BondFragments->ListOfMolecules.size() << " possible bond fragmentation configs" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Writing " << BondFragments->ListOfMolecules.size() << " possible bond fragmentation configs" << endl);
     if (BondFragments->OutputConfigForListOfFragments(configuration, SortIndex))
-      Log() << Verbose(1) << "All configs written." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "All configs written." << endl);
     else
-      Log() << Verbose(1) << "Some config writing failed." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Some config writing failed." << endl);
 
     // store force index reference file
@@ -703,5 +705,9 @@
 
     // store Adjacency file
-    StoreAdjacencyToFile(configuration->configpath);
+    char *filename = Malloc<char> (MAXSTRINGSIZE, "molecule::FragmentMolecule - *filename");
+    strcpy(filename, FRAGMENTPREFIX);
+    strcat(filename, ADJACENCYFILE);
+    StoreAdjacencyToFile(configuration->configpath, filename);
+    Free(&filename);
 
     // store Hydrogen saturation correction file
@@ -715,12 +721,12 @@
 
     // free memory for bond part
-    Log() << Verbose(1) << "Freeing bond memory" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Freeing bond memory" << endl);
     delete(FragmentList); // remove bond molecule from memory
     Free(&SortIndex);
   } else {
-    Log() << Verbose(1) << "FragmentList is zero on return, splitting failed." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "FragmentList is zero on return, splitting failed." << endl);
   }
   delete(BondFragments);
-  Log() << Verbose(0) << "End of bond fragmentation." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "End of bond fragmentation." << endl);
 
   return ((int)(!FragmentationToDo)+1);    // 1 - continue, 2 - stop (no fragmentation occured)
@@ -741,12 +747,12 @@
   line << path << "/" << FRAGMENTPREFIX << ORDERATSITEFILE;
   file.open(line.str().c_str());
-  Log() << Verbose(1) << "Writing OrderAtSite " << ORDERATSITEFILE << " ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Writing OrderAtSite " << ORDERATSITEFILE << " ... " << endl);
   if (file != NULL) {
     ActOnAllAtoms( &atom::OutputOrder, &file );
     file.close();
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
     return true;
   } else {
-    Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl);
     return false;
   }
@@ -769,5 +775,5 @@
   ifstream file;
 
-  Log() << Verbose(1) << "Begin of ParseOrderAtSiteFromFile" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of ParseOrderAtSiteFromFile" << endl);
   line << path << "/" << FRAGMENTPREFIX << ORDERATSITEFILE;
   file.open(line.str().c_str());
@@ -790,8 +796,8 @@
     SetAtomValueToIndexedArray( MaxArray, &atom::nr, &atom::MaxOrder );
 
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
     status = true;
   } else {
-    Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl);
     status = false;
   }
@@ -799,5 +805,5 @@
   Free(&MaxArray);
 
-  Log() << Verbose(1) << "End of ParseOrderAtSiteFromFile" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "End of ParseOrderAtSiteFromFile" << endl);
   return status;
 };
@@ -816,5 +822,5 @@
   int SP, Removal;
 
-  Log() << Verbose(2) << "Looking for removal candidate." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Looking for removal candidate." << endl);
   SP = -1; //0;  // not -1, so that Root is never removed
   Removal = -1;
@@ -843,6 +849,4 @@
 
   Leaf->BondDistance = mol->BondDistance;
-  for(int i=NDIM*2;i--;)
-    Leaf->cell_size[i] = mol->cell_size[i];
 
   // first create the minimal set of atoms from the KeySet
@@ -903,8 +907,8 @@
       }
     } else {
-      eLog() << Verbose(1) << "Son " << Runner->Name << " has father " << FatherOfRunner->Name << " but its entry in SonList is " << SonList[FatherOfRunner->nr] << "!" << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "Son " << Runner->Name << " has father " << FatherOfRunner->Name << " but its entry in SonList is " << SonList[FatherOfRunner->nr] << "!" << endl);
     }
     if ((LonelyFlag) && (Leaf->AtomCount > 1)) {
-      Log() << Verbose(0) << *Runner << "has got bonds only to hydrogens!" << endl;
+      DoLog(0) && (Log() << Verbose(0) << *Runner << "has got bonds only to hydrogens!" << endl);
     }
 #ifdef ADDHYDROGEN
@@ -926,5 +930,5 @@
 {
   atom **SonList = Calloc<atom*>(AtomCount, "molecule::StoreFragmentFromStack: **SonList");
-  molecule *Leaf = new molecule(elemente);
+  molecule *Leaf = World::getInstance().createMolecule();
 
 //  Log() << Verbose(1) << "Begin of StoreFragmentFromKeyset." << endl;
@@ -1053,8 +1057,8 @@
     TouchedList[j] = -1;
   }
-  Log() << Verbose(2) << "Remaining local nr.s on snake stack are: ";
+  DoLog(2) && (Log() << Verbose(2) << "Remaining local nr.s on snake stack are: ");
   for(KeySet::iterator runner = FragmentSet->begin(); runner != FragmentSet->end(); runner++)
-    Log() << Verbose(0) << (*runner) << " ";
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << (*runner) << " ");
+  DoLog(0) && (Log() << Verbose(0) << endl);
   TouchedIndex = 0; // set Index to 0 for list of atoms added on this level
 };
@@ -1133,10 +1137,10 @@
         Log() << Verbose(1+verbosity) << "Enough items on stack for a fragment!" << endl;
         // store fragment as a KeySet
-        Log() << Verbose(2) << "Found a new fragment[" << FragmentSearch->FragmentCounter << "], local nr.s are: ";
+        DoLog(2) && (Log() << Verbose(2) << "Found a new fragment[" << FragmentSearch->FragmentCounter << "], local nr.s are: ");
         for(KeySet::iterator runner = FragmentSearch->FragmentSet->begin(); runner != FragmentSearch->FragmentSet->end(); runner++)
-          Log() << Verbose(0) << (*runner) << " ";
-        Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << (*runner) << " ");
+        DoLog(0) && (Log() << Verbose(0) << endl);
         //if (!CheckForConnectedSubgraph(FragmentSearch->FragmentSet))
-          //eLog() << Verbose(1) << "The found fragment is not a connected subgraph!" << endl;
+          //DoeLog(1) && (eLog()<< Verbose(1) << "The found fragment is not a connected subgraph!" << endl);
         InsertFragmentIntoGraph(FragmentSearch);
       }
@@ -1218,7 +1222,7 @@
 {
   bond *Binder = NULL;
-  Log() << Verbose(0) << "Free'ing all found lists. and resetting index lists" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Free'ing all found lists. and resetting index lists" << endl);
   for(int i=Order;i--;) {
-    Log() << Verbose(1) << "Current SP level is " << i << ": ";
+    DoLog(1) && (Log() << Verbose(1) << "Current SP level is " << i << ": ");
     Binder = FragmentSearch.BondsPerSPList[2*i];
     while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
@@ -1231,5 +1235,5 @@
     cleanup(FragmentSearch.BondsPerSPList[2*i], FragmentSearch.BondsPerSPList[2*i+1]);
     // also start and end node
-    Log() << Verbose(0) << "cleaned." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "cleaned." << endl);
   }
 };
@@ -1261,12 +1265,12 @@
   int SP = -1;
 
-  Log() << Verbose(0) << "Starting BFS analysis ..." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Starting BFS analysis ..." << endl);
   for (SP = 0; SP < (Order-1); SP++) {
-    Log() << Verbose(1) << "New SP level reached: " << SP << ", creating new SP list with " << FragmentSearch.BondsPerSPCount[SP] << " item(s)";
+    DoLog(1) && (Log() << Verbose(1) << "New SP level reached: " << SP << ", creating new SP list with " << FragmentSearch.BondsPerSPCount[SP] << " item(s)");
     if (SP > 0) {
-      Log() << Verbose(0) << ", old level closed with " << FragmentSearch.BondsPerSPCount[SP-1] << " item(s)." << endl;
+      DoLog(0) && (Log() << Verbose(0) << ", old level closed with " << FragmentSearch.BondsPerSPCount[SP-1] << " item(s)." << endl);
       FragmentSearch.BondsPerSPCount[SP] = 0;
     } else
-      Log() << Verbose(0) << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "." << endl);
 
     RemainingWalkers = FragmentSearch.BondsPerSPCount[SP];
@@ -1278,8 +1282,8 @@
       Predecessor = CurrentEdge->leftatom;    // ... and leftatom is predecessor
       AtomKeyNr = Walker->nr;
-      Log() << Verbose(0) << "Current Walker is: " << *Walker << " with nr " << Walker->nr << " and SP of " << SP << ", with " << RemainingWalkers << " remaining walkers on this level." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Current Walker is: " << *Walker << " with nr " << Walker->nr << " and SP of " << SP << ", with " << RemainingWalkers << " remaining walkers on this level." << endl);
       // check for new sp level
       // go through all its bonds
-      Log() << Verbose(1) << "Going through all bonds of Walker." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Going through all bonds of Walker." << endl);
       for (BondList::const_iterator Runner = Walker->ListOfBonds.begin(); Runner != Walker->ListOfBonds.end(); (++Runner)) {
         OtherWalker = (*Runner)->GetOtherAtom(Walker);
@@ -1289,19 +1293,19 @@
   #endif
                                                               ) {  // skip hydrogens and restrict to fragment
-          Log() << Verbose(2) << "Current partner is " << *OtherWalker << " with nr " << OtherWalker->nr << " in bond " << *(*Runner) << "." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "Current partner is " << *OtherWalker << " with nr " << OtherWalker->nr << " in bond " << *(*Runner) << "." << endl);
           // set the label if not set (and push on root stack as well)
           if ((OtherWalker != Predecessor) && (OtherWalker->GetTrueFather()->nr > RootKeyNr)) { // only pass through those with label bigger than Root's
             FragmentSearch.ShortestPathList[OtherWalker->nr] = SP+1;
-            Log() << Verbose(3) << "Set Shortest Path to " << FragmentSearch.ShortestPathList[OtherWalker->nr] << "." << endl;
+            DoLog(3) && (Log() << Verbose(3) << "Set Shortest Path to " << FragmentSearch.ShortestPathList[OtherWalker->nr] << "." << endl);
             // add the bond in between to the SP list
             Binder = new bond(Walker, OtherWalker); // create a new bond in such a manner, that bond::rightatom is always the one more distant
             add(Binder, FragmentSearch.BondsPerSPList[2*(SP+1)+1]);
             FragmentSearch.BondsPerSPCount[SP+1]++;
-            Log() << Verbose(3) << "Added its bond to SP list, having now " << FragmentSearch.BondsPerSPCount[SP+1] << " item(s)." << endl;
+            DoLog(3) && (Log() << Verbose(3) << "Added its bond to SP list, having now " << FragmentSearch.BondsPerSPCount[SP+1] << " item(s)." << endl);
           } else {
             if (OtherWalker != Predecessor)
-              Log() << Verbose(3) << "Not passing on, as index of " << *OtherWalker << " " << OtherWalker->GetTrueFather()->nr << " is smaller than that of Root " << RootKeyNr << "." << endl;
+              DoLog(3) && (Log() << Verbose(3) << "Not passing on, as index of " << *OtherWalker << " " << OtherWalker->GetTrueFather()->nr << " is smaller than that of Root " << RootKeyNr << "." << endl);
             else
-              Log() << Verbose(3) << "This is my predecessor " << *Predecessor << "." << endl;
+              DoLog(3) && (Log() << Verbose(3) << "This is my predecessor " << *Predecessor << "." << endl);
           }
         } else Log() << Verbose(2) << "Is not in the restricted keyset or skipping hydrogen " << *OtherWalker << "." << endl;
@@ -1319,11 +1323,11 @@
 {
   bond *Binder = NULL;
-  Log() << Verbose(0) << "Printing all found lists." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Printing all found lists." << endl);
   for(int i=1;i<Order;i++) {    // skip the root edge in the printing
     Binder = FragmentSearch.BondsPerSPList[2*i];
-    Log() << Verbose(1) << "Current SP level is " << i << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Current SP level is " << i << "." << endl);
     while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
       Binder = Binder->next;
-      Log() << Verbose(2) << *Binder << endl;
+      DoLog(2) && (Log() << Verbose(2) << *Binder << endl);
     }
   }
@@ -1369,6 +1373,6 @@
   int Counter = FragmentSearch.FragmentCounter; // mark current value of counter
 
-  Log() << Verbose(0) << endl;
-  Log() << Verbose(0) << "Begin of PowerSetGenerator with order " << Order << " at Root " << *FragmentSearch.Root << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
+  DoLog(0) && (Log() << Verbose(0) << "Begin of PowerSetGenerator with order " << Order << " at Root " << *FragmentSearch.Root << "." << endl);
 
   SetSPList(Order, FragmentSearch);
@@ -1382,10 +1386,10 @@
   // creating fragments with the found edge sets  (may be done in reverse order, faster)
   int SP = CountNumbersInBondsList(Order, FragmentSearch);
-  Log() << Verbose(0) << "Total number of edges is " << SP << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Total number of edges is " << SP << "." << endl);
   if (SP >= (Order-1)) {
     // start with root (push on fragment stack)
-    Log() << Verbose(0) << "Starting fragment generation with " << *FragmentSearch.Root << ", local nr is " << FragmentSearch.Root->nr << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Starting fragment generation with " << *FragmentSearch.Root << ", local nr is " << FragmentSearch.Root->nr << "." << endl);
     FragmentSearch.FragmentSet->clear();
-    Log() << Verbose(0) << "Preparing subset for this root and calling generator." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Preparing subset for this root and calling generator." << endl);
 
     // prepare the subset and call the generator
@@ -1397,10 +1401,10 @@
     Free(&BondsList);
   } else {
-    Log() << Verbose(0) << "Not enough total number of edges to build " << Order << "-body fragments." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Not enough total number of edges to build " << Order << "-body fragments." << endl);
   }
 
   // as FragmentSearch structure is used only once, we don't have to clean it anymore
   // remove root from stack
-  Log() << Verbose(0) << "Removing root again from stack." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Removing root again from stack." << endl);
   FragmentSearch.FragmentSet->erase(FragmentSearch.Root->nr);
 
@@ -1409,5 +1413,5 @@
 
   // return list
-  Log() << Verbose(0) << "End of PowerSetGenerator." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "End of PowerSetGenerator." << endl);
   return (FragmentSearch.FragmentCounter - Counter);
 };
